OpenShot Audio Library | OpenShotAudio: juce::GenericInterpolator< InterpolatorTraits, memorySize > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
juce::GenericInterpolator< InterpolatorTraits, memorySize > Class Template Reference

`#include <juce_GenericInterpolator.h>`

## Public Member Functions
| GenericInterpolator (GenericInterpolator &&) noexcept=default
GenericInterpolator & | operator= (GenericInterpolator &&) noexcept=default
void | reset () noexcept
int | process (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce) noexcept
int | process (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, int numInputSamplesAvailable, int wrapAround) noexcept
int | processAdding (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, float gain) noexcept
int | processAdding (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, int numInputSamplesAvailable, int wrapAround, float gain) noexcept

## Static Public Member Functions
static constexpr float | getBaseLatency () noexcept

## Detailed Description

template<class InterpolatorTraits, int memorySize>
class juce::GenericInterpolator< InterpolatorTraits, memorySize >

An interpolator base class for resampling streams of floats.

Note that the resamplers are stateful, so when there's a break in the continuity of the input stream you're feeding it, you should call reset() before feeding it any new data. And like with any other stateful filter, if you're resampling multiple channels, make sure each one uses its own interpolator object.

See also
  LagrangeInterpolator, CatmullRomInterpolator, WindowedSincInterpolator, LinearInterpolator, ZeroOrderHoldInterpolator

Definition at line 40 of file juce_GenericInterpolator.h.

## Constructor & Destructor Documentation

## ◆ GenericInterpolator()

template<class InterpolatorTraits , int memorySize>

juce::GenericInterpolator< InterpolatorTraits, memorySize >::GenericInterpolator | ( |  | ) |
| inlinenoexcept

Definition at line 53 of file juce_GenericInterpolator.h.

## Member Function Documentation

## ◆ getBaseLatency()

template<class InterpolatorTraits , int memorySize>

static constexpr float juce::GenericInterpolator< InterpolatorTraits, memorySize >::getBaseLatency | ( |  | ) |
| inlinestaticconstexprnoexcept

Returns the latency of the interpolation algorithm in isolation.

In the context of resampling the total latency of a process using the interpolator is the base latency divided by the speed ratio.

Definition at line 63 of file juce_GenericInterpolator.h.

## ◆ process() [1/2]

template<class InterpolatorTraits , int memorySize>

int juce::GenericInterpolator< InterpolatorTraits, memorySize >::process | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce )
| inlinenoexcept

Resamples a stream of samples.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results into
  numOutputSamplesToProduce | the number of output samples that should be created

Returns
  the actual number of input samples that were used

Definition at line 89 of file juce_GenericInterpolator.h.

## ◆ process() [2/2]

template<class InterpolatorTraits , int memorySize>

int juce::GenericInterpolator< InterpolatorTraits, memorySize >::process | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | int | numInputSamplesAvailable,
|  | int | wrapAround )
| inlinenoexcept

Resamples a stream of samples.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results into
  numOutputSamplesToProduce | the number of output samples that should be created
  numInputSamplesAvailable | the number of available input samples. If it needs more samples than available, it either wraps back for wrapAround samples, or it feeds zeroes
  wrapAround | if the stream exceeds available samples, it wraps back for wrapAround samples. If wrapAround is set to 0, it will feed zeroes.

Returns
  the actual number of input samples that were used

Definition at line 116 of file juce_GenericInterpolator.h.

## ◆ processAdding() [1/2]

template<class InterpolatorTraits , int memorySize>

int juce::GenericInterpolator< InterpolatorTraits, memorySize >::processAdding | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | float | gain )
| inlinenoexcept

Resamples a stream of samples, adding the results to the output data with a gain.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results to - the result values will be added to any pre-existing data in this buffer after being multiplied by the gain factor
  numOutputSamplesToProduce | the number of output samples that should be created
  gain | a gain factor to multiply the resulting samples by before adding them to the destination buffer

Returns
  the actual number of input samples that were used

Definition at line 147 of file juce_GenericInterpolator.h.

## ◆ processAdding() [2/2]

template<class InterpolatorTraits , int memorySize>

int juce::GenericInterpolator< InterpolatorTraits, memorySize >::processAdding | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | int | numInputSamplesAvailable,
|  | int | wrapAround,
|  | float | gain )
| inlinenoexcept

Resamples a stream of samples, adding the results to the output data with a gain.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results to - the result values will be added to any pre-existing data in this buffer after being multiplied by the gain factor
  numOutputSamplesToProduce | the number of output samples that should be created
  numInputSamplesAvailable | the number of available input samples. If it needs more samples than available, it either wraps back for wrapAround samples, or it feeds zeroes
  wrapAround | if the stream exceeds available samples, it wraps back for wrapAround samples. If wrapAround is set to 0, it will feed zeroes.
  gain | a gain factor to multiply the resulting samples by before adding them to the destination buffer

Returns
  the actual number of input samples that were used

Definition at line 180 of file juce_GenericInterpolator.h.

## ◆ reset()

template<class InterpolatorTraits , int memorySize>

void juce::GenericInterpolator< InterpolatorTraits, memorySize >::reset | ( |  | ) |
| inlinenoexcept

Resets the state of the interpolator.

Call this when there's a break in the continuity of the input data stream.

Definition at line 72 of file juce_GenericInterpolator.h.

The documentation for this class was generated from the following file:

- juce_GenericInterpolator.h